diff -Naur --exclude=CVS --exclude=configs linux/fs/namei.c linux-openmosix/fs/namei.c
--- linux/fs/namei.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/namei.c	2004-02-05 10:51:20.000000000 +0100
@@ -13,6 +13,15 @@
  */
 /* [Feb-Apr 2000, AV] Rewrite to the new namespace architecture.
  */
+/* heavy changes by openMosix
+   we basically don't use the Linux name lookup services, but do it on our own since we cannot 
+   rely on dcache. 
+
+   This part is old and needs to be rewritten
+
+   Moshe Bar
+
+*/
 
 #include <linux/init.h>
 #include <linux/slab.h>
@@ -26,6 +35,15 @@
 #include <asm/namei.h>
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#include <linux/proc_fs.h>
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#define	replaced_name	name_left
+#endif /* CONFIG_MOSIX_DFSA */
+
 #define ACC_MODE(x) ("\000\004\002\006"[(x)&O_ACCMODE])
 
 /* [Feb-1997 T. Schoebel-Theuer]
@@ -238,6 +256,7 @@
 	spin_unlock(&arbitration_lock);
 	return 0;
 }
+
 int deny_write_access(struct file * file)
 {
 	spin_lock(&arbitration_lock);
@@ -325,6 +344,25 @@
 	return result;
 }
 
+#ifdef CONFIG_MOSIX_DFSA
+static inline int
+dfsa_crossed(struct nameidata *nd, struct vfsmount *prevmnt)
+{
+	if(nd->flags & LOOKUP_STAYFS)
+	{
+		mntput(prevmnt);
+		if(nd->mnt != prevmnt)
+		{
+			if(current->mosix.dflags & DREMOTE)
+				return(-EDOITATHOME);
+			nd->flags &= ~LOOKUP_STAYFS;
+			current->mosix.dflags &= ~DSTATSDOWN;
+		}
+	}
+	return(0);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * This limits recursive symlink follows to 8, while
  * limiting consecutive symlinks to 40.
@@ -439,6 +477,15 @@
 		;
 }
 
+#ifdef CONFIG_MOSIX_FS
+static inline int
+unacceptable_mfs_fs(unsigned long magic)
+{
+	return(magic == PROC_SUPER_MAGIC || magic == 0x42494e4d);
+						  /* (BINMisc) */
+}
+#endif /* CONFIG_MOSIX_FS */
+
 /*
  * Name resolution.
  *
@@ -453,7 +500,29 @@
 	struct inode *inode;
 	int err;
 	unsigned int lookup_flags = nd->flags;
-
+#ifdef CONFIG_MOSIX_DFSA
+	struct vfsmount *prevmnt = NULL;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	char *orig_part = NULL, *orig_ref = NULL, *tmpname;
+	unsigned int flattings = 0;
+	char *free_me = NULL;
+#endif /* CONFIG_MOSIX_FS */
+
+#ifdef CONFIG_MOSIX_DFSA
+	/* an early error in path_init? (callers did not error-check there!) */
+	if(nd->flags & LOOKUP_DOITATHOME)
+	{
+		path_release(nd);
+		return(-EDOITATHOME);
+	}
+	if(nd->flags & LOOKUP_REPLACENAME)
+	{
+		nd->flags &= ~LOOKUP_REPLACENAME;
+		name = nd->replaced_name;
+		nd->replaced_name = NULL;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	while (*name=='/')
 		name++;
 	if (!*name)
@@ -461,7 +530,12 @@
 
 	inode = nd->dentry->d_inode;
 	if (current->link_count)
+#ifdef CONFIG_MOSIX_FS
+		lookup_flags = LOOKUP_FOLLOW |
+			(nd->flags & (LOOKUP_MFS|LOOKUP_MFS_MFS));
+#else
 		lookup_flags = LOOKUP_FOLLOW;
+#endif /* CONFIG_MOSIX_FS */
 
 	/* At this point we know we have a real path component. */
 	for(;;) {
@@ -469,6 +543,47 @@
 		struct qstr this;
 		unsigned int c;
 
+#ifdef CONFIG_MOSIX_FS
+		/* have we consumed the whole link and can continue
+		 * with the original name?
+		 */
+		if(orig_part && name >= orig_part)
+		{
+			name = orig_ref + (name - orig_part);
+			orig_part = orig_ref = NULL;
+			if(free_me)
+			{
+				kfree(free_me);
+				free_me = NULL;
+			}
+			flattings = 0;	/* real progress made */
+			nd->flags &= ~LOOKUP_MFS_MFS;
+		}
+		if(inode->i_op->express_lookup)
+		{
+			if(current->link_count)
+			/* flatten the path by passing it back to top-level,
+			 * so all is included in the same express_lookup */
+			{
+				if(!(nd->name_left =
+					kmalloc(strlen(name)+1, GFP_KERNEL)))
+				{
+					err = -ENOMEM;
+					break;
+				}
+				strcpy(nd->name_left, name);
+				return(0);
+			}
+			err = inode->i_op->express_lookup(nd, (char **)&name);
+			if(IS_ERR((const void *)err))
+				break;
+			if(!name)
+				goto return_err; /*trick: err can be positive*/
+			inode = nd->dentry->d_inode;
+			continue;
+		}
+#endif /* CONFIG_MOSIX_FS */
+
 		err = permission(inode, MAY_EXEC);
 		dentry = ERR_PTR(err);
  		if (err)
@@ -504,7 +619,25 @@
 			case 2:	
 				if (this.name[1] != '.')
 					break;
+#ifdef CONFIG_MOSIX_FS
+				if((nd->flags & LOOKUP_MFS) &&
+					!current->link_count && !orig_ref &&
+					is_mfs_root(nd))
+				{
+					nd->name_left = (char *)name;
+					path_release(nd);
+					goto return_base;
+				}
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+				if(nd->flags & LOOKUP_STAYFS)
+					prevmnt = mntget(nd->mnt);
+#endif /* CONFIG_MOSIX_DFSA */
 				follow_dotdot(nd);
+#ifdef CONFIG_MOSIX_DFSA
+				if((err = dfsa_crossed(nd, prevmnt)))
+					break;
+#endif /* CONFIG_MOSIX_DFSA */
 				inode = nd->dentry->d_inode;
 				/* fallthrough */
 			case 1:
@@ -528,8 +661,16 @@
 				break;
 		}
 		/* Check mountpoints.. */
+#ifdef CONFIG_MOSIX_DFSA
+		if(nd->flags & LOOKUP_STAYFS)
+			prevmnt = mntget(nd->mnt);
+#endif /* CONFIG_MOSIX_DFSA */
 		while (d_mountpoint(dentry) && __follow_down(&nd->mnt, &dentry))
 			;
+#ifdef CONFIG_MOSIX_DFSA
+		if((err = dfsa_crossed(nd, prevmnt)))
+			break;
+#endif /* CONFIG_MOSIX_DFSA */
 
 		err = -ENOENT;
 		inode = dentry->d_inode;
@@ -546,6 +687,43 @@
 				goto return_err;
 			err = -ENOENT;
 			inode = nd->dentry->d_inode;
+#ifdef CONFIG_MOSIX_FS
+			if(nd->name_left)
+			{
+				unsigned int l = strlen(nd->name_left);
+
+				err = -ELOOP;
+				if(flattings++ > 8)
+				{
+					kfree(nd->name_left);
+					nd->name_left = NULL;
+					break;
+				}
+				err = -ENOMEM;
+				if(!(tmpname = kmalloc(l + strlen(name) + 2,
+								GFP_KERNEL)))
+				{
+					kfree(nd->name_left);
+					nd->name_left = NULL;
+					break;
+				}
+				sprintf(tmpname, "%s/%s", nd->name_left, name);
+				kfree(nd->name_left);
+				if(current->link_count)
+				{
+					nd->name_left = tmpname;
+					return(0);
+				}
+				if(free_me)
+					kfree(free_me);
+				free_me = tmpname;
+				nd->name_left = NULL;
+				orig_part = tmpname + l + 1;
+				orig_ref = (char *)name;
+				name = tmpname;
+				continue;
+			}
+#endif /* CONFIG_MOSIX_FS */
 			if (!inode)
 				break;
 			err = -ENOTDIR; 
@@ -556,8 +734,19 @@
 			nd->dentry = dentry;
 		}
 		err = -ENOTDIR; 
+#ifdef CONFIG_MOSIX_FS
+		if (!inode->i_op->express_lookup)
+#endif /* CONFIG_MOSIX_FS */
 		if (!inode->i_op->lookup)
 			break;
+#ifdef CONFIG_MOSIX_FS
+		if(lookup_flags & LOOKUP_MFS)
+		{
+			err = -EACCES;
+			if(unacceptable_mfs_fs(nd->mnt->mnt_sb->s_magic))
+				break;
+		}
+#endif /* CONFIG_MOSIX_FS */
 		continue;
 		/* here ends the main loop */
 
@@ -572,7 +761,25 @@
 			case 2:	
 				if (this.name[1] != '.')
 					break;
+#ifdef CONFIG_MOSIX_FS
+				if((nd->flags & LOOKUP_MFS) &&
+					!current->link_count && !orig_ref &&
+					is_mfs_root(nd))
+				{
+					nd->name_left = (char *)name;
+					path_release(nd);
+					goto return_base;
+				}
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+				if(nd->flags & LOOKUP_STAYFS)
+					prevmnt = mntget(nd->mnt);
+#endif /* CONFIG_MOSIX_DFSA */
 				follow_dotdot(nd);
+#ifdef CONFIG_MOSIX_DFSA
+				if((err = dfsa_crossed(nd, prevmnt)))
+					break;
+#endif /* CONFIG_MOSIX_DFSA */
 				inode = nd->dentry->d_inode;
 				/* fallthrough */
 			case 1:
@@ -590,8 +797,16 @@
 			if (IS_ERR(dentry))
 				break;
 		}
+#ifdef CONFIG_MOSIX_DFSA
+		if(nd->flags & LOOKUP_STAYFS)
+			prevmnt = mntget(nd->mnt);
+#endif /* CONFIG_MOSIX_DFSA */
 		while (d_mountpoint(dentry) && __follow_down(&nd->mnt, &dentry))
 			;
+#ifdef CONFIG_MOSIX_DFSA
+		if((err = dfsa_crossed(nd, prevmnt)))
+			break;
+#endif /* CONFIG_MOSIX_DFSA */
 		inode = dentry->d_inode;
 		if ((lookup_flags & LOOKUP_FOLLOW)
 		    && inode && inode->i_op && inode->i_op->follow_link) {
@@ -600,6 +815,29 @@
 			if (err)
 				goto return_err;
 			inode = nd->dentry->d_inode;
+#ifdef CONFIG_MOSIX_FS
+			if(nd->name_left)
+			{
+				err = -ELOOP;
+				if(flattings++ > 8)
+				{
+					kfree(nd->name_left);
+					nd->name_left = NULL;
+					break;
+				}
+				err = -ENOMEM;
+				if(free_me)
+					kfree(free_me);
+				if(current->link_count)
+					return(0);
+				orig_ref = (char *)name;
+				name = free_me = nd->name_left;
+				nd->name_left = NULL;
+				lookup_flags = nd->flags;
+				orig_part = NULL;
+				continue;
+			}
+#endif /* CONFIG_MOSIX_FS */
 		} else {
 			dput(nd->dentry);
 			nd->dentry = dentry;
@@ -609,9 +847,26 @@
 			goto no_inode;
 		if (lookup_flags & LOOKUP_DIRECTORY) {
 			err = -ENOTDIR; 
+#ifdef CONFIG_MOSIX_FS
+			if (!inode->i_op || (!inode->i_op->lookup &&
+						!inode->i_op->express_lookup))
+#else
 			if (!inode->i_op || !inode->i_op->lookup)
+#endif /* CONFIG_MOSIX_FS */
+				break;
+		}
+#ifdef CONFIG_MOSIX_FS
+		if(lookup_flags & LOOKUP_MFS)
+		{
+			umode_t mod = inode->i_mode & S_IFMT;
+
+			err = -EACCES;
+			if(mod != S_IFREG && mod != S_IFDIR && mod != S_IFLNK)
+				break;
+			if(unacceptable_mfs_fs(nd->mnt->mnt_sb->s_magic))
 				break;
 		}
+#endif /* CONFIG_MOSIX_FS */
 		goto return_base;
 no_inode:
 		err = -ENOENT;
@@ -643,6 +898,10 @@
 			}
 		}
 return_base:
+#ifdef CONFIG_MOSIX_FS
+		if(free_me)
+			kfree(free_me);
+#endif /* CONFIG_MOSIX_FS */
 		return 0;
 out_dput:
 		dput(dentry);
@@ -650,6 +909,10 @@
 	}
 	path_release(nd);
 return_err:
+#ifdef CONFIG_MOSIX_FS
+	if(free_me)
+		kfree(free_me);
+#endif /* CONFIG_MOSIX_FS */
 	return err;
 }
 
@@ -719,12 +982,53 @@
 		dput(olddentry);
 		mntput(oldmnt);
 	}
+#ifdef CONFIG_MOSIX_DFSA
+	tell_process(current, DREQ_NOTUPTODATE);
+#endif /* CONFIG_MOSIX_DFSA */
 }
 
 /* SMP-safe */
 static inline int
 walk_init_root(const char *name, struct nameidata *nd)
 {
+#ifdef CONFIG_MOSIX_DFSA
+	if(nd->flags & LOOKUP_STAYFS)
+	{
+		struct task_struct *p = current;
+
+		if(current->fs->altroot)
+		{
+			p->mosix.dflags &= ~DSTATSDOWN;
+			nd->flags &= ~LOOKUP_STAYFS;
+		}
+		else if(p->mosix.dflags & DDEPUTY)
+			nd->flags &= ~LOOKUP_STAYFS;
+		else if(((p->mosix.dflags & DREMOTE) || CAN_DFSA(p)) &&
+			name_starts_in_dfsa((char **)&name, nd))
+		{
+			if(!(p->mosix.dflags & DREMOTE) && !p->link_count)
+				p->mosix.dflags |= DSTATSDOWN;
+			if(!*name)
+				return(0);
+			nd->flags |= LOOKUP_REPLACENAME;
+			nd->replaced_name = (char *)name;
+			return(1);
+		}
+		else if(p->mosix.dflags & DREMOTE)
+		{
+			nd->flags |= LOOKUP_DOITATHOME;
+			nd->mnt = NULL;
+			nd->dentry = NULL;
+			return(1);
+		}
+		else
+			p->mosix.dflags &= ~DSTATSDOWN;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	if(nd->flags & LOOKUP_MFS)
+		return(mfs_walk_init_root(nd));
+#endif /* CONFIG_MOSIX_FS */
 	read_lock(&current->fs->lock);
 	if (current->fs->altroot && !(nd->flags & LOOKUP_NOALT)) {
 		nd->mnt = mntget(current->fs->altrootmnt);
@@ -755,12 +1059,48 @@
 {
 	nd->last_type = LAST_ROOT; /* if there are only slashes... */
 	nd->flags = flags;
+#ifdef CONFIG_MOSIX_FS
+	nd->name_left = NULL;
+	nd->complete_flags = 0;
+#ifdef CONFIG_MOSIX_DIAG
+	if(flags & LOOKUP_MFS)
+		panic("MFS should have own path_init!");
+#endif /* CONFIG_MOSIX_DIAG */
+#endif /* CONFIG_MOSIX_FS */
 	if (*name=='/')
 		return walk_init_root(name,nd);
 	read_lock(&current->fs->lock);
 	nd->mnt = mntget(current->fs->pwdmnt);
 	nd->dentry = dget(current->fs->pwd);
 	read_unlock(&current->fs->lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if(!nd->dentry)	/* possible on REMOTE! */
+	{
+		nd->flags |= LOOKUP_DOITATHOME;
+		return(1);
+	}
+
+	if(nd->flags & LOOKUP_STAYFS)
+	{
+		struct task_struct *p = current;
+
+		if(p->mosix.dflags & DDEPUTY)
+			nd->flags &= ~LOOKUP_STAYFS;
+		else if(((p->mosix.dflags & DREMOTE) || CAN_DFSA(p)) &&
+								within_dfsa(nd))
+		{
+			if(!(p->mosix.dflags & DREMOTE))
+				p->mosix.dflags |= DSTATSDOWN;
+		}
+		else
+		{
+			if(p->mosix.dflags & DREMOTE)
+				nd->flags |= LOOKUP_DOITATHOME;
+			else
+				p->mosix.dflags &= ~DSTATSDOWN;
+		}
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	return 1;
 }
 
@@ -859,6 +1199,10 @@
 		err = path_lookup(tmp, flags, nd);
 		putname(tmp);
 	}
+#ifdef CONFIG_MOSIX_FS
+	else
+		nd->complete_flags = 0;
+#endif /* CONFIG_MOSIX_FS */
 	return err;
 }
 
@@ -927,7 +1271,11 @@
  *  3. We should have write and exec permissions on dir
  *  4. We can't do it if dir is immutable (done in permission())
  */
+#ifdef CONFIG_MOSIX_FS
+inline int may_create(struct inode *dir, struct dentry *child) {
+#else
 static inline int may_create(struct inode *dir, struct dentry *child) {
+#endif /* CONFIG_MOSIX_FS */
 	if (child->d_inode)
 		return -EEXIST;
 	if (IS_DEADDIR(dir))
@@ -1005,16 +1353,45 @@
 	struct dentry *dentry;
 	struct dentry *dir;
 	int count = 0;
-
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+        unsigned int more_flags = 0;
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
+	
 	acc_mode = ACC_MODE(flag);
-
+#ifdef CONFIG_MOSIX_FS
+        if(!pathname)   /* special argument to skip path-search */
+        {
+                if(flag & O_CREAT)
+                        goto low_create;
+                else
+                        goto low_nocreate;
+        }
+        nd->express_function = EF_OPEN;
+        nd->complete_args.ints.i1 = flag;
+        nd->complete_args.ints.i2 = mode & ~current->fs->umask;
+        more_flags |= LOOKUP_COMPLETE;
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+        if(current->mosix.dirty_bits & FILP_OPEN_SYSCALL)
+                more_flags |= LOOKUP_STAYFS;
+#endif /* CONFIG_MOSIX_DFSA */
+	
 	/*
 	 * The simplest case - just a plain lookup.
 	 */
 	if (!(flag & O_CREAT)) {
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+                error = path_lookup(pathname, lookup_flags(flag)|more_flags, nd);
+#else
 		error = path_lookup(pathname, lookup_flags(flag), nd);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
 		if (error)
 			return error;
+#ifdef CONFIG_MOSIX_FS
+                if(nd->complete_flags & COMPLETE_DONE)
+                        return(0);
+               low_nocreate:
+#endif /* CONFIG_MOSIX_FS */
 		dentry = nd->dentry;
 		goto ok;
 	}
@@ -1022,9 +1399,18 @@
 	/*
 	 * Create - we need to know the parent.
 	 */
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+        error = path_lookup(pathname, LOOKUP_PARENT|more_flags, nd);
+#else
 	error = path_lookup(pathname, LOOKUP_PARENT, nd);
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		return error;
+#ifdef CONFIG_MOSIX_FS
+        if(nd->complete_flags & COMPLETE_DONE)
+                return(0);
+        low_create:
+#endif /* CONFIG_MOSIX_FS */
 
 	/*
 	 * We have the parent and last component. First of all, check
@@ -1213,7 +1599,11 @@
 }
 
 /* SMP-safe */
+#ifdef CONFIG_MOSIX_FS
+struct dentry *lookup_create(struct nameidata *nd, int is_dir)
+#else
 static struct dentry *lookup_create(struct nameidata *nd, int is_dir)
+#endif /* CONFIG_MOSIX_FS */
 {
 	struct dentry *dentry;
 
@@ -1274,7 +1664,17 @@
 	if (IS_ERR(tmp))
 		return PTR_ERR(tmp);
 
+#ifdef CONFIG_MOSIX_FS
+        nd.express_function = EF_MKNOD;
+        nd.complete_args.ints.i1 = mode & ~current->fs->umask;
+        error = path_lookup(tmp, LOOKUP_COMPLETE|LOOKUP_PARENT, &nd);
+#else
 	error = path_lookup(tmp, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_FS
+        if(nd.complete_flags & COMPLETE_DONE)
+                goto out;
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto out;
 	dentry = lookup_create(&nd, 0);
@@ -1342,9 +1742,24 @@
 		struct dentry *dentry;
 		struct nameidata nd;
 
+#ifdef CONFIG_MOSIX_FS
+                nd.express_function = EF_MKDIR;
+                nd.complete_args.ints.i1 = mode & ~current->fs->umask;
+                error = path_lookup(tmp, LOOKUP_COMPLETE|LOOKUP_PARENT|LOOKUP_STAYFS,
+                                                                       &nd);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+                error = path_lookup(tmp, LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
 		error = path_lookup(tmp, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 		if (error)
 			goto out;
+#ifdef CONFIG_MOSIX_FS
+                if(nd.complete_flags & COMPLETE_DONE)
+                        goto out;
+#endif /* CONFIG_MOSIX_FS */
 		dentry = lookup_create(&nd, 1);
 		error = PTR_ERR(dentry);
 		if (!IS_ERR(dentry)) {
@@ -1438,10 +1853,23 @@
 	if(IS_ERR(name))
 		return PTR_ERR(name);
 
+#ifdef CONFIG_MOSIX_FS
+        nd.express_function = EF_RMDIR;
+        error = path_lookup(name, LOOKUP_COMPLETE|LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+        error = path_lookup(name, LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
 	error = path_lookup(name, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto exit;
-
+#ifdef CONFIG_MOSIX_FS
+        if(nd.complete_flags & COMPLETE_DONE)
+                goto exit;
+#endif /* CONFIG_MOSIX_FS */
+	
 	switch(nd.last_type) {
 		case LAST_DOTDOT:
 			error = -ENOTEMPTY;
@@ -1506,9 +1934,22 @@
 	if(IS_ERR(name))
 		return PTR_ERR(name);
 
+#ifdef CONFIG_MOSIX_FS
+        nd.express_function = EF_UNLINK;
+        error = path_lookup(name, LOOKUP_COMPLETE|LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+        error = path_lookup(name, LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
 	error = path_lookup(name, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto exit;
+#ifdef CONFIG_MOSIX_FS
+        if(nd.complete_flags & COMPLETE_DONE)
+                goto exit;
+#endif /* CONFIG_MOSIX_FS */
 	error = -EISDIR;
 	if (nd.last_type != LAST_NORM)
 		goto exit1;
@@ -1577,9 +2018,24 @@
 		struct dentry *dentry;
 		struct nameidata nd;
 
+#ifdef CONFIG_MOSIX_FS
+                nd.express_function = EF_SYMLINK;
+                nd.complete_parg = from;
+                error = path_lookup(to, LOOKUP_COMPLETE|LOOKUP_PARENT|LOOKUP_STAYFS,
+                                                                        &nd);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+                error = path_lookup(to, LOOKUP_PARENT|LOOKUP_STAYFS, &nd);
+#else
 		error = path_lookup(to, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 		if (error)
 			goto out;
+#ifdef CONFIG_MOSIX_FS
+                if(nd.complete_flags & COMPLETE_DONE)
+                        goto out;
+#endif /* CONFIG_MOSIX_FS */
 		dentry = lookup_create(&nd, 0);
 		error = PTR_ERR(dentry);
 		if (!IS_ERR(dentry)) {
@@ -1654,13 +2110,38 @@
 	if (!IS_ERR(to)) {
 		struct dentry *new_dentry;
 		struct nameidata nd, old_nd;
-
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+                unsigned int more_flags = 0;
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
+		
+#ifdef CONFIG_MOSIX_DFSA
+                error = __user_walk(oldname, LOOKUP_POSITIVE|LOOKUP_STAYFS, &old_nd);
+#else
 		error = __user_walk(oldname, LOOKUP_POSITIVE, &old_nd);
+#endif /* CONFIG_MOSIX_DFSA */	
 		if (error)
 			goto exit;
+
+#ifdef CONFIG_MOSIX_DFSA
+                if(current->mosix.dflags & (DREMOTE|DSTATSDOWN))
+                        more_flags |= LOOKUP_STAYFS;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+                nd.express_function = EF_LINK;
+                nd.complete_args.oldnd = &old_nd;
+                more_flags |= LOOKUP_COMPLETE;
+#endif /* CONFIG_MOSIX_FS */
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+                error = path_lookup(to, LOOKUP_PARENT|more_flags, &nd);
+#else
 		error = path_lookup(to, LOOKUP_PARENT, &nd);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
 		if (error)
 			goto out;
+#ifdef CONFIG_MOSIX_FS
+                if(nd.complete_flags & COMPLETE_DONE)
+                        goto out;
+#endif /* CONFIG_MOSIX_FS */
 		error = -EXDEV;
 		if (old_nd.mnt != nd.mnt)
 			goto out_release;
@@ -1853,12 +2334,36 @@
 	struct dentry * old_dir, * new_dir;
 	struct dentry * old_dentry, *new_dentry;
 	struct nameidata oldnd, newnd;
-
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+        unsigned int more_flags = 0;
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
+
+#ifdef CONFIG_MOSIX_DFSA
+        error = path_lookup(oldname, LOOKUP_PARENT|LOOKUP_STAYFS, &oldnd);
+#else
 	error = path_lookup(oldname, LOOKUP_PARENT, &oldnd);
+#endif /* CONFIG_MOSIX_DFSA */
 	if (error)
 		goto exit;
 
+#ifdef CONFIG_MOSIX_DFSA
+        if(current->mosix.dflags & (DREMOTE|DSTATSDOWN))
+                more_flags |= LOOKUP_STAYFS;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+        newnd.express_function = EF_RENAME;
+        newnd.complete_args.oldnd = &oldnd;
+        more_flags |= LOOKUP_COMPLETE;
+#endif /* CONFIG_MOSIX_FS */
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+        error = path_lookup(newname, LOOKUP_PARENT|more_flags, &newnd);
+#else
 	error = path_lookup(newname, LOOKUP_PARENT, &newnd);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_FS
+        if(newnd.complete_flags & COMPLETE_DONE)
+                goto exit1;
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto exit1;
 
@@ -1965,8 +2470,16 @@
 		if (!walk_init_root(link, nd))
 			/* weird __emul_prefix() stuff did it */
 			goto out;
+#ifdef CONFIG_MOSIX_FS
+		if(nd->flags & LOOKUP_MFS)
+			nd->flags |= LOOKUP_MFS_MFS;
+#endif /* CONFIG_MOSIX_FS */
 	}
 	res = link_path_walk(link, nd);
+#ifdef CONFIG_MOSIX_FS
+	if(!nd->name_left)
+		nd->flags &= ~LOOKUP_MFS_MFS;
+#endif /* CONFIG_MOSIX_FS */
 out:
 	if (current->link_count || res || nd->last_type!=LAST_NORM)
 		return res;
diff -Naur --exclude=CVS --exclude=configs linux/fs/namespace.c linux-openmosix/fs/namespace.c
--- linux/fs/namespace.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/namespace.c	2004-02-05 10:51:21.000000000 +0100
@@ -21,6 +21,17 @@
 #include <linux/seq_file.h>
 #include <linux/namespace.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/file.h>
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
 struct vfsmount *do_kern_mount(const char *type, int flags, char *name, void *data);
 int do_remount_sb(struct super_block *sb, int flags, void * data);
 void kill_super(struct super_block *sb);
@@ -40,7 +51,7 @@
 
 struct vfsmount *alloc_vfsmnt(char *name)
 {
-	struct vfsmount *mnt = kmem_cache_alloc(mnt_cache, GFP_KERNEL); 
+	struct vfsmount *mnt = kmem_cache_alloc(mnt_cache, GFP_KERNEL);
 	if (mnt) {
 		memset(mnt, 0, sizeof(struct vfsmount));
 		atomic_set(&mnt->mnt_count,1);
@@ -237,6 +248,11 @@
 	}
 	if (mnt->mnt_sb->s_op->show_options)
 		err = mnt->mnt_sb->s_op->show_options(m, mnt);
+	/* seq_puts(m, " 0 0"); */
+#ifdef CONFIG_MOSIX_DFSA
+	if (mnt->mnt_dfsa)
+		seq_printf(m, ",dfsa=%d", mnt->mnt_dfsa);
+#endif /* CONFIG_MOSIX_DFSA */
 	seq_puts(m, " 0 0\n");
 	return err;
 }
@@ -331,6 +347,15 @@
 	}
 
 	down_write(&current->namespace->sem);
+#ifdef CONFIG_MOSIX_DFSA
+	/*	down_half_interruptible(&current->namespace->sem);*/
+	/* while (!down_write_trylock(&current->namespace->sem)) */
+	if(current->namespace == init_task.namespace &&  (retval = dfsa_setmnt(mnt, 0, 0)))
+	{
+		up_write(&current->namespace->sem);
+		return(retval);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	spin_lock(&dcache_lock);
 
 	if (atomic_read(&sb->s_active) == 1) {
@@ -387,9 +412,9 @@
 }
 
 /*
- *	The 2.0 compatible umount. No flags. 
+ *	The 2.0 compatible umount. No flags.
  */
- 
+
 asmlinkage long sys_oldumount(char * name)
 {
 	return sys_umount(name,0);
@@ -496,7 +521,6 @@
 	err = path_lookup(old_name, LOOKUP_POSITIVE|LOOKUP_FOLLOW, &old_nd);
 	if (err)
 		return err;
-
 	down_write(&current->namespace->sem);
 	err = -EINVAL;
 	if (check_mnt(nd->mnt) && (!recurse || check_mnt(old_nd.mnt))) {
@@ -532,6 +556,9 @@
 {
 	int err;
 	struct super_block * sb = nd->mnt->mnt_sb;
+#ifdef CONFIG_MOSIX_DFSA
+	int odfsa = 0, new_dfsa, cng_dfsa = 0;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
@@ -542,11 +569,36 @@
 	if (nd->dentry != nd->mnt->mnt_root)
 		return -EINVAL;
 
+#ifdef CONFIG_MOSIX_DFSA
+	if(current->namespace == init_task.namespace &&
+	   (cng_dfsa = dfsa_option(data, &new_dfsa)))
+	{
+		down_write(&current->namespace->sem);
+		/* down_half_interruptible(&current->namespace->sem); */
+		odfsa = nd->mnt->mnt_dfsa;
+		nd->mnt->mnt_dfsa = new_dfsa;
+		err = dfsa_setmnt(nd->mnt, new_dfsa, flags);
+		up_write(&current->namespace->sem);
+		if(err)
+			return(err);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	down_write(&sb->s_umount);
 	err = do_remount_sb(sb, flags, data);
 	if (!err)
 		nd->mnt->mnt_flags=mnt_flags;
 	up_write(&sb->s_umount);
+#ifdef CONFIG_MOSIX_DFSA
+	if(err && cng_dfsa) {
+		/* undo - unless someone else played with mount meanwhile */
+		down_write(&current->namespace->sem);
+		/* down_half_interruptible(&current->namespace->sem); */
+		if(nd->mnt->mnt_dfsa == new_dfsa)
+			dfsa_setmnt(nd->mnt, odfsa, nd->mnt->mnt_sb->s_flags);
+		/* up(&current->namespace->sem);*/
+		up_write(&current->namespace->sem);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	return err;
 }
 
@@ -555,6 +607,9 @@
 	struct nameidata old_nd, parent_nd;
 	struct vfsmount *p;
 	int err = 0;
+#ifdef CONFIG_MOSIX_DFSA
+	int odfsa = 0;
+#endif
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (!old_name || !*old_name)
@@ -569,7 +624,14 @@
 	err = -EINVAL;
 	if (!check_mnt(nd->mnt) || !check_mnt(old_nd.mnt))
 		goto out;
-
+#ifdef CONFIG_MOSIX_DFSA
+	odfsa = old_nd.mnt->mnt_dfsa;
+	if(odfsa) {
+		if((err = dfsa_setmnt(old_nd.mnt, 0, 0)))
+			goto out;
+		old_nd.mnt->mnt_dfsa = 0;
+	}
+#endif
 	err = -ENOENT;
 	down(&nd->dentry->d_inode->i_zombie);
 	if (IS_DEADDIR(nd->dentry->d_inode))
@@ -602,7 +664,20 @@
 	spin_unlock(&dcache_lock);
 out1:
 	up(&nd->dentry->d_inode->i_zombie);
+
 out:
+#ifdef CONFIG_MOSIX_DFSA
+       if(err && odfsa) {
+               int e = dfsa_setmnt(old_nd.mnt, odfsa, 0);
+
+               if(e) {
+                       printk("Moving a mount-point: failed restoring DFSA "
+                              "option (errno=%d)\n", e);
+                       printk("following a failed attempt to move '%s'\n", old_name);
+	       } else
+                      old_nd.mnt->mnt_dfsa = odfsa;
+      }
+#endif /* CONFIG_MOSIX_DFSA */
 	up_write(&current->namespace->sem);
 	if (!err)
 		path_release(&parent_nd);
@@ -655,7 +730,7 @@
 	int i;
 	unsigned long page;
 	unsigned long size;
-	
+
 	*where = 0;
 	if (!data)
 		return 0;
@@ -674,7 +749,7 @@
 
 	i = size - copy_from_user((void *)page, data, size);
 	if (!i) {
-		free_page(page); 
+		free_page(page);
 		return -EFAULT;
 	}
 	if (i != PAGE_SIZE)
@@ -703,6 +778,9 @@
 	struct nameidata nd;
 	int retval = 0;
 	int mnt_flags = 0;
+#ifdef CONFIG_MOSIX_DFSA
+	int dfsa_opt;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	/* Discard magic */
 	if ((flags & MS_MGC_MSK) == MS_MGC_VAL)
@@ -739,6 +817,25 @@
 	else
 		retval = do_add_mount(&nd, type_page, flags, mnt_flags,
 				      dev_name, data_page);
+#ifdef CONFIG_MOSIX_DFSA
+	down_write(&current->namespace->sem); /* possible location of dead_lock for tmpfs under oMFS? Moshe */
+	/* down_half_interruptible(&current->namespace->sem); what is this?? Moshe */
+	if(!retval && current->namespace == init_task.namespace && 
+	   dfsa_option((char *)data_page, &dfsa_opt) &&
+	   d_mountpoint(nd.dentry) && follow_down(&nd.mnt, &nd.dentry)
+	   && (nd.mnt->mnt_dfsa = dfsa_opt) &&
+	   dfsa_setmnt(nd.mnt, dfsa_opt, flags))
+	{
+		/* too late to undo the mount - all we can do is complain: */
+		nd.mnt->mnt_dfsa = 0;
+		printk("openMosix: mount succeeded, but DFSA option failed: "
+			"if you can fix the problem, run:\n");
+		printk("'mount -o remount,dfsa=%d %s %s'\n", dfsa_opt,
+			dev_name, dir_name);
+	}
+	up_write(&current->namespace->sem);
+	/* up(&current->namespace->sem); */
+#endif /* CONFIG_MOSIX_DFSA */
 	path_release(&nd);
 	return retval;
 }
@@ -861,6 +958,11 @@
 	putname(dir_page);
 out1:
 	free_page(type_page);
+/* #ifdef CONFIG_MOSIX_FS maybe this should be turned on again?? Moshe */
+/*         /\* for consistency *\/ */
+/* 	if(retval > 0 && !strcmp(type, "mfs")) */
+/* 		mosix_rebuild_file_list(); */
+/* #endif */
 	return retval;
 }
 
@@ -870,7 +972,12 @@
 	struct fs_struct *fs;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	/* DFSA is disabled, so no REMOTE roots (and no cwd's away) */
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		task_lock(p);
 		fs = p->fs;
 		if (fs) {
@@ -887,6 +994,33 @@
 	read_unlock(&tasklist_lock);
 }
 
+#ifdef CONFIG_MOSIX_DFSA
+void restore_dfsa_mounts(void)
+{
+	struct list_head *p;
+	struct namespace *n = current->namespace;
+	int told = 0;
+
+	down_write(&n->sem);
+	list_for_each(p, &n->list) {
+		struct vfsmount *tmp = list_entry(p, struct vfsmount, mnt_list);
+
+		if(tmp->mnt_dfsa &&
+		   dfsa_setmnt(tmp, tmp->mnt_dfsa, tmp->mnt_sb->s_flags))
+		{
+			if(!told++)
+				printk("One or more partitions failed to restore DFSA"
+				       " status after pivot_root.\n"
+				       "If you can fix the problem, please remount "
+				       "the affected partition(s) with the appropriate"
+				       " dfsa= option\n");
+			tmp->mnt_dfsa = 0;
+		}
+	}
+	up_write(&n->sem);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * Moves the current root to put_root, and sets root/cwd of all processes
  * which had them on the old root to new_root.
@@ -909,6 +1043,10 @@
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
+#ifdef CONFIG_MOSIX_DFSA
+	if(current->namespace == init_task.namespace && (error = disable_dfsa()))
+		return(error);
+#endif /* CONFIG_MOSIX_DFSA */
 	lock_kernel();
 
 	error = __user_walk(new_root, LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_DIRECTORY, &new_nd);
@@ -938,6 +1076,15 @@
 		goto out2;
 	if (d_unhashed(old_nd.dentry) && !IS_ROOT(old_nd.dentry))
 		goto out2;
+#ifdef CONFIG_MOSIX_FS
+	if(new_nd.dentry->d_inode->i_sb->s_magic == MFS_SUPER_MAGIC ||
+		old_nd.dentry->d_inode->i_sb->s_magic == MFS_SUPER_MAGIC)
+	{
+		/* MFS does not support mounts (which are otherwise ignored) */
+		error = -EINVAL;
+		goto out2;
+	}
+#endif /* CONFIG_MOSIX_FS */
 	error = -EBUSY;
 	if (new_nd.mnt == user_nd.mnt || old_nd.mnt == user_nd.mnt)
 		goto out2; /* loop */
@@ -965,6 +1112,9 @@
 	attach_mnt(user_nd.mnt, &old_nd);
 	attach_mnt(new_nd.mnt, &root_parent);
 	spin_unlock(&dcache_lock);
+#ifdef CONFIG_MOSIX_FS
+	mfs_change_root(user_nd.dentry, user_nd.mnt, new_nd.dentry, new_nd.mnt);
+#endif /* CONFIG_MOSIX_FS */
 	chroot_fs_refs(&user_nd, &new_nd);
 	error = 0;
 	path_release(&root_parent);
@@ -978,6 +1128,12 @@
 	path_release(&new_nd);
 out0:
 	unlock_kernel();
+#ifdef CONFIG_MOSIX_DFSA
+       if(current->namespace == init_task.namespace) {
+               enable_dfsa();
+               restore_dfsa_mounts();
+       }
+#endif /* CONFIG_MOSIX_DFSA */
 	return error;
 out3:
 	spin_unlock(&dcache_lock);
diff -Naur --exclude=CVS --exclude=configs linux/fs/nfsd/auth.c linux-openmosix/fs/nfsd/auth.c
--- linux/fs/nfsd/auth.c	2000-07-24 08:04:10.000000000 +0200
+++ linux-openmosix/fs/nfsd/auth.c	2004-02-05 10:51:22.000000000 +0100
@@ -9,6 +9,9 @@
 #include <linux/sunrpc/svc.h>
 #include <linux/sunrpc/svcauth.h>
 #include <linux/nfsd/nfsd.h>
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
 
 #define	CAP_NFSD_MASK (CAP_FS_MASK|CAP_TO_MASK(CAP_SYS_RESOURCE))
 void
@@ -20,6 +23,9 @@
 	if (rqstp->rq_userset)
 		return;
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if (exp->ex_flags & NFSEXP_ALLSQUASH) {
 		cred->cr_uid = exp->ex_anon_uid;
 		cred->cr_gid = exp->ex_anon_gid;
